/// <reference types="node" />
import React from "react";
import { SoundLevelMap, ZegoBroadcastMessageInfo2, ZegoBrowserCheckProp, ZegoNotification } from "../../../model";
import { ZegoBroadcastMessageInfo } from "zego-express-engine-webrtm/sdk/code/zh/ZegoExpressEntity.d";
import { ZegoDeviceInfo } from "zego-express-engine-webrtc/sdk/code/zh/ZegoExpressEntity.web";
import { ZegoSuperBoardView } from "zego-superboard-web";
import { ZegoCloudUserList } from "../../../modules/tools/UserListManager";
export declare class ZegoRoomMobile extends React.PureComponent<ZegoBrowserCheckProp> {
    static contextType: React.Context<import("../context/showManage").ShowManageType>;
    state: {
        localStream: undefined | MediaStream;
        layOutStatus: "ONE_VIDEO" | "INVITE" | "USER_LIST" | "MESSAGE" | "LAYOUT" | "MANAGE" | "WHITEBOARD";
        userLayoutStatus: "Auto" | "Grid" | "Sidebar";
        zegoCloudUserList: ZegoCloudUserList;
        memberList: ZegoCloudUserList;
        messageList: ZegoBroadcastMessageInfo2[];
        notificationList: ZegoNotification[];
        micOpen: boolean;
        cameraOpen: boolean;
        showMore: boolean;
        connecting: boolean;
        firstLoading: boolean;
        cameraFront: boolean;
        showFooter: boolean;
        isNetworkPoor: boolean;
        soundLevel: SoundLevelMap;
        liveCountdown: number;
        liveStatus: "1" | "0";
        screenSharingUserList: ZegoCloudUserList;
        zegoSuperBoardView: ZegoSuperBoardView | null;
        isZegoWhiteboardSharing: boolean;
    };
    micStatus: -1 | 0 | 1;
    cameraStatus: -1 | 0 | 1;
    localUserPin: boolean;
    faceModel: 0 | 1 | -1;
    notifyTimer: NodeJS.Timeout | null;
    footerTimer: NodeJS.Timeout;
    cameraDevices: ZegoDeviceInfo[];
    userUpdateCallBack: () => void;
    localStreamID: string;
    safariLimitationNoticed: -1 | 0 | 1;
    iosLimitationNoticed: number;
    showNotSupported: number;
    get isCDNLive(): boolean;
    componentDidMount(): void;
    componentWillUnmount(): void;
    componentDidUpdate(preProps: ZegoBrowserCheckProp, preState: {
        localStream: undefined | MediaStream;
        layOutStatus: "ONE_VIDEO" | "INVITE" | "USER_LIST" | "MESSAGE";
        messageList: ZegoBroadcastMessageInfo[];
        notificationList: ZegoNotification[];
        micOpen: boolean;
        cameraOpen: boolean;
        showMore: boolean;
        screenSharingUserList: ZegoCloudUserList;
        userLayoutStatus: "Auto" | "Grid" | "Sidebar";
    }): void;
    initSDK(): Promise<void>;
    createStream(): Promise<boolean>;
    toggleMic(): Promise<void>;
    toggleCamera(): Promise<void>;
    switchCamera(): Promise<void>;
    toggleLayOut(layOutStatus: "ONE_VIDEO" | "INVITE" | "USER_LIST" | "MESSAGE" | "LAYOUT" | "WHITEBOARD"): void;
    sendMessage(msg: string): Promise<void>;
    onblur: (e: {
        path?: any[];
    }) => void;
    openMore(): void;
    leaveRoom(): void;
    private confirmLeaveRoom;
    getAllUser(): ZegoCloudUserList;
    getAllMemberList(): ZegoCloudUserList;
    getShownUser(): ZegoCloudUserList;
    getHiddenUser(): JSX.Element;
    private _selectedUser;
    get showSelf(): boolean | "";
    handleLayoutChange(selectLayout: "Auto" | "Grid" | "Sidebar"): Promise<boolean>;
    getListScreen(): JSX.Element | undefined;
    getLayoutScreen(): JSX.Element | undefined;
    clickVideo(e: MouseEvent): void;
    setLive(): Promise<void>;
    liveCountdownTimer(): void;
    toggleWhiteboardSharing(): Promise<void>;
    isCreatingWhiteboardSharing: boolean;
    createWhiteboardSharing(): Promise<void>;
    closeWhiteboardSharing(): void;
    render(): React.ReactNode;
}
